%define major 6
%define libname %mklibname ffi %major
%define develname %mklibname -d ffi

Name:		libffi
Version:	3.1
%define subrel 1
Release:	%mkrel 4
Summary:	A portable foreign function interface library
Group:		System/Libraries
License:	BSD
URL:		http://sourceware.org/libffi
Source0:	ftp://sourceware.org/pub/libffi/libffi-%{version}.tar.gz
Patch0:		libffi-3.1-git-Fix-paths-in-libffi.pc.in.patch
Patch1:		libffi-3.1-fix-exec-stack.patch
Patch2:		libffi-aarch64-rhbz1174037.patch
Patch3:		libffi-3.1-aarch64-fix-exec-stack.patch

%description
Compilers for high level languages generate code that follow certain
conventions.  These conventions are necessary, in part, for separate
compilation to work.  One such convention is the "calling convention".
The calling convention is a set of assumptions made by the compiler
about where function arguments will be found on entry to a function.
A calling convention also specifies where the return value for a function
is found.

Some programs may not know at the time of compilation what arguments
are to be passed to a function.  For instance, an interpreter may be
told at run-time about the number and types of arguments used to call
a given function.  `Libffi' can be used in such programs to provide
a bridge from the interpreter program to compiled code.

The `libffi' library provides a portable, high level programming
interface to various calling conventions.  This allows a programmer to
call any function specified by a call interface description at run time.

FFI stands for Foreign Function Interface.  A foreign function
interface is the popular name for the interface that allows code
written in one language to call code written in another language. 
The `libffi' library really only provides the lowest, machine dependent
layer of a fully featured foreign function interface.  A layer must
exist above `libffi' that handles type conversions for values passed
between the two languages.

%package -n %libname
Summary:	A portable foreign function interface library
Group:		System/Libraries
Provides:       %name = %version-%release
Provides:       %name%major = %version-%release
%description -n %libname
Compilers for high level languages generate code that follow certain
conventions.  These conventions are necessary, in part, for separate
compilation to work.  One such convention is the "calling convention".
The calling convention is a set of assumptions made by the compiler
about where function arguments will be found on entry to a function.
A calling convention also specifies where the return value for a function
is found.

Some programs may not know at the time of compilation what arguments
are to be passed to a function.  For instance, an interpreter may be
told at run-time about the number and types of arguments used to call
a given function.  `Libffi' can be used in such programs to provide
a bridge from the interpreter program to compiled code.

The `libffi' library provides a portable, high level programming
interface to various calling conventions.  This allows a programmer to
call any function specified by a call interface description at run time.

FFI stands for Foreign Function Interface.  A foreign function
interface is the popular name for the interface that allows code
written in one language to call code written in another language.
The `libffi' library really only provides the lowest, machine dependent
layer of a fully featured foreign function interface.  A layer must
exist above `libffi' that handles type conversions for values passed
between the two languages.

%package -n %develname
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Requires(post): /sbin/install-info
Requires(preun): /sbin/install-info
Provides:	 libffi-devel = %version-%release
Provides:	 ffi%{major}-devel = %version-%release
Obsoletes:	 %{mklibname -d ffi 5}
Obsoletes:	 %{mklibname -d ffi 6}

%description -n %develname
This package contains libraries and header files for developing
applications that use %{name}.


%prep
%autosetup -p1


%build
autoreconf -vfi
%configure2_5x --disable-static
%make_build


%install
%make_install LIBDIR=%{_libdir}
find %{buildroot} -name '*.la' -exec rm -f {} ';'
rm -f %{buildroot}%{_infodir}/dir


%post -n %develname
%_install_info libffi.info

%preun -n %develname
%_remove_install_info libffi.info


%files -n %libname
%doc LICENSE README
%{_libdir}/*.so.%{major}*

%files -n %develname
%{_libdir}/pkgconfig/*.pc
%{_libdir}/%{name}-%{version}
%{_libdir}/*.so
%{_mandir}/man3/*
%{_infodir}/libffi.info.*


%changelog
* Sat Jul 01 2017 akien <akien> 3.1-4.1.mga5
+ Revision: 1108873
- Sync patches with Fedora to fix CVE-2017-1000376 (mga#21122)

* Wed Oct 15 2014 umeabot <umeabot> 3.1-4.mga5
+ Revision: 745917
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 3.1-3.mga5
+ Revision: 681456
- Mageia 5 Mass Rebuild

* Sun Aug 10 2014 akien <akien> 3.1-2.mga5
+ Revision: 661520
- Fix pkg-config file (upstream patch)

* Wed Jun 04 2014 sander85 <sander85> 3.1-1.mga5
+ Revision: 632883
- New version: 3.1

* Sat Oct 19 2013 umeabot <umeabot> 3.0.13-2.mga4
+ Revision: 523735
- Mageia 4 Mass Rebuild

* Fri May 24 2013 tv <tv> 3.0.13-1.mga4
+ Revision: 426596
- new release

* Thu May 09 2013 colin <colin> 3.0.11-3.mga3
+ Revision: 412789
- Rename -devel package to fit library policy (gcj no longer conflicts)

* Sat Jan 12 2013 umeabot <umeabot> 3.0.11-2.mga3
+ Revision: 357102
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Aug 06 2012 luigiwalser <luigiwalser> 3.0.11-1.mga3
+ Revision: 278977
- 3.0.11 (updates major to 6)

* Fri Aug 26 2011 tv <tv> 3.0.10-1.mga2
+ Revision: 135554
- new release

* Sun Mar 27 2011 dmorgan <dmorgan> 3.0.9-4.mga1
+ Revision: 77949
- Add an other provides to help to choose the one we want

* Sun Mar 27 2011 dmorgan <dmorgan> 3.0.9-3.mga1
+ Revision: 77909
- Fix provides

  + ennael <ennael>
    - clean spec file

* Wed Jan 12 2011 dmorgan <dmorgan> 3.0.9-2.mga1
+ Revision: 7046
- imported package libffi

